#include "header.h"


void parse_args(int argc, char **argv)
{
	int	    i;
	int	    errflag = 0;
	char	    *program_name = *argv;
	extern char *optarg;


	while((i = getopt(argc, argv, "r:s:w:?")) != EOF) {
		switch (i) {
			case 'r':
				num_readers = atoi(optarg);
				break;
			case 's':
				buffer_size = atoi(optarg);
				break;
                        case 'w': 
                                num_writers = atoi(optarg);
                                break;
			case '?':
				errflag++;
				break;
		}
	}

	if(num_writers >= MAX_WRITER_NUMBER) {
		errflag++;
		fprintf(stderr, "ERROR: num_writers must be less\ 
                                       than %d\n", MAX_WRITER_NUMBER);
	}

	if(num_readers >= MAX_READER_NUMBER) {
		errflag++;
		fprintf(stderr, "ERROR: num_readers must be less\
                                        than %d\n", MAX_READER_NUMBER);
	}

	i = num_readers * num_writers;

	if(i >= MAX_THREAD_NUMBER) {
		errflag++;
		fprintf(stderr, "ERROR: maximun threads number\
                         must be less than %d\n", MAX_THREAD_NUMBER);
	}

	if(errflag) {
		fprintf(stderr, USAGE, program_name);
		exit (2);
	}
}



void release()
{
        int i, j;

        for(i = 0; i < num_writers; i++) {
        	if(pthread_mutex_destroy(&cond_mutex[i]) != 0)
			perror("Can't destroy cond_mutex");
	
       	if(pthread_mutex_destroy(&mutex_r[i]) != 0)
			perror("Can't destroy mutex_r"); 
        }

        for(i = 0; i < num_writers; i++) {
		j = i * 3;
        	if(shmctl(shmid[j], IPC_RMID, 0) < 0)
			perror("Read_count shmctl Failed");

/*
	j = i * 3;

        if(shmctl(shmid[j], IPC_RMID, 0) < 0)
		perror("Read_count shmctl Failed");
	j++;

        if(shmctl(shmid[j], IPC_RMID, 0) < 0)
		perror("checksum shmctl failed");
	j++;
        if(shmctl(shmid[j], IPC_RMID, 0) < 0)
		perror("shmptr shmctl failed");

*/
        }
}



int sys_error(const char *msg, int line)
{
	char syserr_msg [256];

	sprintf(syserr_msg, "%s: %s\n", msg, strerror (errno));
	error(syserr_msg, line);
}

void error(const char *msg, int line)
{
	fprintf(stderr, "ERROR [line: %d] %s\n", line, msg);
	if(line>= 2600)
	release();
	exit(-1);
}
